
LoadData = function()

	SetGlobals();

	if storage == nil then
		storage = {["numbers"] = {}, ["strings"] = {}};
	else
		data_loaded = true;
		-- convert saved strings back into numbers
		data.numbers = ConvertStringsToNumbers(storage.numbers);
	end
	
	SetDefaults();
	
	data.numbers.overview_width_ratio = data.numbers.overview_width_ratio / 100000000000000;

	local current_day = Turbine.Engine.GetDate().DayOfYear;
	if data.numbers.current_day ~= current_day then
		data.numbers.current_day = current_day;
		data.numbers.points_current_day = 0;
	end

end

SetGlobals = function()

	_G.version = "1.6";
	_G.Ranks = { [0]=0, [1]=500, [2]=1250, [3]=2750, [4]=5750, [5]=14750, [6]=33500, [7]=71000, [8]=146000, [9]=258500, [10]=408500, [11]=633500, [12]=1008500, [13]=1608500, [14]=2508500, [15]=3708500 };
	_G.minimal_width = 360;
	_G.wallet_loaded = false;
	_G.new_fight = false;
	_G.data_loaded = false;
	_G.points_last_fight = 0;
	_G.current_commendations = 0;
	_G.storage = Turbine.PluginData.Load(Turbine.DataScope.Character,"PvMP_Plus");
	_G.last_commendations = tonumber(Turbine.PluginData.Load(Turbine.DataScope.Server,"PvMP_Plus"));
	_G.data = {["numbers"] = {}, ["strings"] = {}};
	-- _G.local_player = Turbine.Gameplay.LocalPlayer.GetInstance(); in Updater.lua
	
end

SetDefaults = function()

	if data.numbers.recent_points == nil then data.numbers.recent_points = {} end;
	if data.numbers.current_day == nil then data.numbers.current_day = Turbine.Engine.GetDate().DayOfYear end;
	if data.numbers.points_current_day == nil then data.numbers.points_current_day = 0 end;
	if data.numbers.points_total == nil then data.numbers.points_total = 0 end;
	if data.numbers.overview_width_ratio == nil then data.numbers.overview_width_ratio = 30000000000000 end;
	local fixed_ratio = data.numbers.overview_width_ratio / 100000000000000;
	local display_width = Turbine.UI.Display.GetWidth();
	if data.numbers.overview_x == nil then data.numbers.overview_x = math.floor(display_width / 2 - (minimal_width + (display_width - minimal_width) * fixed_ratio) / 2) end;
	if data.numbers.overview_y == nil then data.numbers.overview_y = 0 end;

end

Plugins["PvMP+"].Unload = function(sender, args)
	storage.strings.version = version;
	data.numbers.overview_width_ratio = data.numbers.overview_width_ratio * 100000000000000;

	-- only save points last hour
	DeleteObsoletePoints();
	
	-- convert data into strings
	storage.numbers = ConvertNumbersToStrings(data.numbers);

	Turbine.PluginData.Save(Turbine.DataScope.Server, "PvMP_Plus", tostring(current_commendations));
	Turbine.PluginData.Save(Turbine.DataScope.Character, "PvMP_Plus", storage);
	data.numbers.overview_width_ratio = data.numbers.overview_width_ratio / 100000000000000;
	--Turbine.Shell.WriteLine("saved");
end

ConvertStringsToNumbers = function(data)
	local temp = {};
	
	for i,j in pairs(data) do
		if type(j) == "table" then
			temp[i] = ConvertStringsToNumbers(j);
		elseif type(j) == "string" then
			local test = tonumber(i);
			if test == nil then
				temp[i] = tonumber(j);
			else
				temp[tonumber(i)] = tonumber(j);
			end
		end
	end

	return temp;
end

ConvertNumbersToStrings = function(data)
	local temp = {};
	
	for i,j in pairs(data) do
		if type(j) == "table" then
			temp[i] = ConvertNumbersToStrings(j);
		elseif type(j) == "number" then
			temp[tostring(i)] = tostring(j);
		end
	end

	return temp;
end

DeleteObsoletePoints = function()
	local new_recent_points = {};
	local now = GetSecondsOfYear();
	
	for i,j in pairs(data.numbers.recent_points) do
		if (now - i <= 3600 and now - i >= 0) then
			new_recent_points[i] = j;		
		end
	end

	data.numbers.recent_points = new_recent_points;
end

GetRemainingPoints = function()
	for i=0, 14 do
		if (data.numbers.points_total >= Ranks[i] and data.numbers.points_total < Ranks[i+1]) then
			return Ranks[i+1] - data.numbers.points_total;
		end
	end
end