InitWindow = class(Turbine.UI.Lotro.Window);
 
function InitWindow:Constructor()

  local width = 200;
  local height = 160;
  local x = Turbine.UI.Display:GetWidth()/2 - width/2;
  local y = Turbine.UI.Display:GetHeight()/2 - height/2;

  Turbine.UI.Lotro.Window.Constructor(self);
  
  self:SetSize(width,height);
  self:SetPosition(x,y);
  self:SetText("PvMP+");
  ------------------------------------------------------------
  self.label_points = Turbine.UI.Label();
  self.label_points:SetParent(self);
  self.label_points:SetSize(width - width/5,30);
  self.label_points:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
  self.label_points:SetPosition(width/10,45);
  self.label_points:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
  self.label_points:SetText(L.Init_Points);

  self.textbox_points = Turbine.UI.Lotro.TextBox();
  self.textbox_points:SetParent(self);
  self.textbox_points:SetSize(width * 4/5,20);
	self.textbox_points:SetText(data.numbers.points_total);
  self.textbox_points:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
  self.textbox_points:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
  self.textbox_points:SetPosition(width/10,82);
  self.textbox_points:SetMultiline(false);
  ------------------------------------------------------------
	self.error_message = Turbine.UI.Label();
	self.error_message:SetParent(self);
	self.error_message:SetSize(width,60);
	self.error_message:SetForeColor(Turbine.UI.Color(255/255,0/255,0/255));
	self.error_message:SetPosition(0,110);
	self.error_message:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
	self.error_message:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	self.error_message:SetVisible(false);
  ------------------------------------------------------------	
  self.okButton = Turbine.UI.Lotro.Button();
  self.okButton:SetParent(self);
  self.okButton:SetPosition(width/2 - self.okButton:GetWidth()/2,95);
  self.okButton:SetText("OK");
	self:SetZOrder(2);
  
  self.okButton.Click = function()
		self:Close();
  end

  self:SetVisible(false);
end

function InitWindow:Open()
	self.error_message:SetVisible(false);
	self:SetHeight(160);
	self.okButton:SetPosition(self:GetWidth()/2 - self.okButton:GetWidth()/2,115);
	self.textbox_points:SetText(data.numbers.points_total);
  self:SetVisible(true);
end

InitWindow.Closed = function(sender, args)
	sender:Close();
end

function InitWindow:Close()
	local parsed_text = string.gsub(string.gsub(self.textbox_points:GetText(), "%.", ""), "%,", "");
	if tonumber(parsed_text) == nil then
		self:SetHeight(180);
		self.okButton:SetPosition(self:GetWidth()/2 - self.okButton:GetWidth()/2,135);
		self.error_message:SetText(L.Strings_Invalid_Input);
		self.error_message:SetVisible(true);
		return;
	end
	
	if (tonumber(parsed_text) > 3708500) then parsed_text = 3708500; end;
	if (tonumber(parsed_text) < 0) then parsed_text = 0; end;
		
	data.numbers.points_total = tonumber(parsed_text);
	self:SetVisible(false);
	overviewWindow:UpdateOverview(true);
end

function InitWindow:DataOutOfSync()
	self.error_message:SetVisible(false);
	self:SetHeight(210);
	self.okButton:SetPosition(self:GetWidth()/2 - self.okButton:GetWidth()/2,165);
	self.error_message:SetText(L.Strings_Data_Out_Of_Sync);
	self.error_message:SetVisible(true);
	self:SetVisible(true);
end