Overview_Settings = class(Turbine.UI.Window);
 
function Overview_Settings:Constructor()

  Turbine.UI.Window.Constructor(self);
	self:SetSize(48, 16);
	self:SetPosition(overviewWindow:GetLeft() + overviewWindow:GetWidth() - self:GetWidth(), overviewWindow:GetTop());

	self.chatButtonWindow = Turbine.UI.Window();
	self.chatButtonWindow:SetParent(self);
	self.chatButtonWindow:SetSize(16,16);
	self.chatButtonWindow:SetVisible(true);
	
	self.chatButton = Turbine.UI.Control();
	self.chatButton:SetParent(self.chatButtonWindow);
	self.chatButton:SetSize(16,16);
		
	self.chatButtonOverlay = Turbine.UI.Control();
	self.chatButtonOverlay:SetParent(self.chatButtonWindow);
	self.chatButtonOverlay:SetSize(16,16);
	self.chatButtonOverlay:SetBackground("PvMP_Plus/Resources/chat.tga");
	self.chatButtonOverlay:SetMouseVisible(false);
	
	self.chatSend = Turbine.UI.Lotro.Quickslot();
	self.chatSend:SetParent(self.chatButton);
	self.chatSend:SetSize(16,16);
	self.chatSend:SetUseOnRightClick(false);
	self.chatSend.MouseDown = function(sender,args)
			if (args.Button == Turbine.UI.MouseButton.Right) then
				self.contextMenu:ShowMenu();
		end
	end
	
	self.chatSendShortcut = Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,nil);
	
	self.contextMenu = Turbine.UI.ContextMenu();
	if data.numbers.selectedChannel == nil then
		data.numbers.selectedChannel = 5; -- 1 = say, 2 = fellow, 3 = raid, 4 = kin, 5 = OOC
	end
	
	self.menuItems = self.contextMenu:GetItems();
	
	self.say = Turbine.UI.MenuItem(L.Say[2],true,false);
	self.say.Click = function(sender,args)
		self:UpdateChannel(self.say,1);
	end
	
	self.fellowship = Turbine.UI.MenuItem(L.Fellowship[2],true,false);
	self.fellowship.Click = function(sender,args)
		self:UpdateChannel(self.fellowship,2);
	end
	
	self.raid = Turbine.UI.MenuItem(L.Raid[2],true,false);
	self.raid.Click = function(sender,args)
		self:UpdateChannel(self.raid,3);
	end
	
	self.kinship = Turbine.UI.MenuItem(L.Kinship[2],true,false);
	self.kinship.Click = function(sender,args)
		self:UpdateChannel(self.kinship,4);
	end
	
	self.ooc = Turbine.UI.MenuItem(L.OOC[2],true,true);
	self.ooc.Click = function(sender,args)
		self:UpdateChannel(self.ooc,5);
	end
	
	self.menuItems:Add(self.say);
	self.menuItems:Add(self.fellowship);
	self.menuItems:Add(self.raid);
	self.menuItems:Add(self.kinship);
	self.menuItems:Add(self.ooc);

	self.plusminus = Turbine.UI.Button();
	self.plusminus:SetParent(self);
	self.plusminus:SetSize(16, 16);
	self.plusminus:SetPosition(32, 0);
	self.plusminus.visible = storage.minimized;
	if self.plusminus.visible then
		self.plusminus:SetBackground("PvMP_Plus/Resources/plus.tga");
	else
		self.plusminus:SetBackground("PvMP_Plus/Resources/minus.tga");
	end
	self.plusminus.MouseDown = function(sender,args)
		storage.minimized = overviewWindow:IsVisible();
		if overviewWindow:IsVisible() then
			self.plusminus:SetBackground("PvMP_Plus/Resources/plus.tga");
			overviewWindow:SetVisible(false);
			self.plusminus.visible = false;
		else
			self.plusminus:SetBackground("PvMP_Plus/Resources/minus.tga");
			overviewWindow:SetVisible(true);
			self.plusminus.visible = true;
		end
	end
	
	self.settings = Turbine.UI.Button();
	self.settings:SetParent(self);
	self.settings:SetSize(16, 16);
	self.settings:SetPosition(16, 0);
	self.settings:SetBackground("PvMP_Plus/Resources/settings_button.tga");
	self.settings.MouseDown = function(sender,args)
			settings:SetVisible(not settings:IsVisible());
	end
	
	self:SetZOrder(1);
	
end

function Overview_Settings:UpdateChannel(clickedItem, index)
	for i = 1, self.menuItems:GetCount() do
		local menuItem = self.menuItems:Get(i);
		menuItem:SetChecked(false);
	end
	clickedItem:SetChecked(true);

	data.numbers.selectedChannel = index;
	self.UpdateChatData();
end

function Overview_Settings:UpdateChatData()
	local blue = "#7F9FFF";
	local red = "#FF3232";
	local beige = "#FFFF99";
	overview_settings_panel.chatSendShortcut:SetData("/"..
		(data.numbers.selectedChannel == 2 and L.Fellowship[1] or
		data.numbers.selectedChannel == 3 and L.Raid[1] or
		data.numbers.selectedChannel == 4 and L.Kinship[1] or
		data.numbers.selectedChannel == 5 and L.OOC[1] or
		L.Say[1]).." "..
		"<rgb="..blue..">"..local_player:GetName().."'s "..L.Points_Type..": </rgb>"..
		"<rgb="..red..">"..L.Total.."</rgb>".."<rgb="..beige..">"..FormatPoints(data.numbers.points_total).."</rgb> - "..
		"<rgb="..red..">"..L.Today.."</rgb>".."<rgb="..beige..">"..FormatPoints(data.numbers.points_current_day).."</rgb> - "..
		"<rgb="..red..">"..L.Overview_Last_Hour.."</rgb>".."<rgb="..beige..">"..FormatPoints(GetPointsLastHour()).."</rgb> - "..
		"<rgb="..red..">"..L.Overview_Last_10min.."</rgb>".."<rgb="..beige..">"..FormatPoints(GetPointsLast10min()).."</rgb> - "..
		"<rgb="..red..">"..L.Overview_Last_Fight.."</rgb>".."<rgb="..beige..">"..FormatPoints(points_last_fight).."</rgb>"
	);
	overview_settings_panel.chatSend:SetShortcut(overview_settings_panel.chatSendShortcut);
end