OverviewWindow = class(Turbine.UI.Window);
 
function OverviewWindow:Constructor()

  Turbine.UI.Window.Constructor(self);
  local width = math.ceil(minimal_width + (Turbine.UI.Display.GetWidth() - minimal_width) * data.numbers.overview_width_ratio);
  local height = 90;
	self:SetSize(width,height);

	self:SetPosition(data.numbers.overview_x,data.numbers.overview_y);
  self:SetWantsKeyEvents(true);
  self:SetMouseVisible(false);
	
	self.bar_start = 50;
	self.bar_end = self:GetWidth() - self.bar_start;
	self.bar_length = self.bar_end - self.bar_start;
	--
	self.empty_bar = Turbine.UI.Label();
	self.empty_bar:SetParent(self);
	self.empty_bar:SetSize(self.bar_length,14);
	self.empty_bar:SetPosition(self.bar_start,27);
	self.empty_bar:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_empty.tga");
	self.empty_bar:SetMouseVisible(false);

	self.filled_bar = Turbine.UI.Label();
	self.filled_bar:SetParent(self);
	self.filled_bar:SetSize(0,14);
	self.filled_bar:SetPosition(self.bar_start,27);
	self.filled_bar:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_filled.tga");
	self.filled_bar:SetMouseVisible(false);

	self.left_end = Turbine.UI.Label();
	self.left_end:SetParent(self);
	self.left_end:SetSize(6,18);
	self.left_end:SetPosition(self.bar_start-3,25);
	self.left_end:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_left.tga");
	self.left_end:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
	self.left_end:SetMouseVisible(false);

	self.right_end = Turbine.UI.Label();
	self.right_end:SetParent(self);
	self.right_end:SetSize(6,18);
	self.right_end:SetPosition(self.bar_end-3,25);
	self.right_end:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_right.tga");	
	self.right_end:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
	self.right_end:SetMouseVisible(false);
	
	self.middle = Turbine.UI.Label();
	self.middle:SetParent(self);
	self.middle:SetSize(self.bar_length-6,18);
	self.middle:SetPosition(self.bar_start+3,25);
	self.middle:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_middle.tga");	
	self.middle:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
	self.middle:SetMouseVisible(false);
	
	self.percentage = Turbine.UI.Label();
	self.percentage:SetParent(self);
  self.percentage:SetSize(width,18);
  self.percentage:SetPosition(0,25);
  self.percentage:SetFont(Turbine.UI.Lotro.Font.Verdana12);
  self.percentage:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.percentage:SetMouseVisible(false);
	
  ------------------------------------------------------------
  self.label_points = Turbine.UI.Label();
  self.label_points:SetParent(self);
  self.label_points:SetSize(width - 108,20); -- label direkt zwischen rank- und commendations-label
  self.label_points:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.label_points:SetPosition(width/2-self.label_points:GetSize()/2,45);
	self.label_points:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.label_points:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	self.label_points:SetFontStyle(Turbine.UI.FontStyle.Outline);
	------------------------------------------------------------
	self.label_day = Turbine.UI.Label();
  self.label_day:SetParent(self);
  self.label_day:SetSize(width/4,20);
  self.label_day:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.label_day:SetPosition(0,70);
	self.label_day:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.label_day:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	self.label_day:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.label_day:SetMouseVisible(false);
  ------------------------------------------------------------
	self.label_last_hour = Turbine.UI.Label();
  self.label_last_hour:SetParent(self);
  self.label_last_hour:SetSize(width/4,20);
  self.label_last_hour:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.label_last_hour:SetPosition(width/4,70);
	self.label_last_hour:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.label_last_hour:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	self.label_last_hour:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.label_last_hour:SetMouseVisible(false);
	------------------------------------------------------------
	self.label_10min = Turbine.UI.Label();
  self.label_10min:SetParent(self);
  self.label_10min:SetSize(width/4,20);
  self.label_10min:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.label_10min:SetPosition(2 * width/4,70);
	self.label_10min:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.label_10min:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	self.label_10min:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.label_10min:SetMouseVisible(false);
	------------------------------------------------------------
  self.label_last_fight = Turbine.UI.Label();
  self.label_last_fight:SetParent(self);
  self.label_last_fight:SetSize(width/4,20);
  self.label_last_fight:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.label_last_fight:SetPosition(3 * width/4,70);
	self.label_last_fight:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.label_last_fight:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	self.label_last_fight:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.label_last_fight:SetMouseVisible(false);
	------------------------------------------------------------
  self.label_commendations = Turbine.UI.Label();
  self.label_commendations:SetParent(self);
  self.label_commendations:SetSize(54,20);
  self.label_commendations:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.label_commendations:SetPosition(width-self.label_commendations:GetWidth(),48);
	self.label_commendations:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.label_commendations:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	self.label_commendations:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.label_commendations:SetMouseVisible(false);
  ------------------------------------------------------------
  self.pic_commendations = Turbine.UI.Label();
  self.pic_commendations:SetParent(self);
  self.pic_commendations:SetSize(32,32);
	self.pic_commendations:SetPosition(width-27-16,18);
	self.pic_commendations:SetBackground(0x41123495);
	self.pic_commendations:SetMouseVisible(false);
  ------------------------------------------------------------
	self.label_rank = Turbine.UI.Label();
  self.label_rank:SetParent(self);
  self.label_rank:SetSize(54,20);
  self.label_rank:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.label_rank:SetPosition(0,48);
	self.label_rank:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.label_rank:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	self.label_rank:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.label_rank:SetMouseVisible(false);
  ------------------------------------------------------------
  self.pic_rank = Turbine.UI.Label();
  self.pic_rank:SetParent(self);
  self.pic_rank:SetSize(32,32);
	self.pic_rank:SetPosition(11,18);
	self.pic_rank:SetMouseVisible(false);
  ------------------------------------------------------------
	self.separator = Turbine.UI.Label();
  self.separator:SetParent(self);
  self.separator:SetSize(width,1);
	self.separator:SetPosition(0,70);
	self.separator:SetBackColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.separator:SetMouseVisible(false);
	------------------------------------------------------------
	self:SetStatsVisibility(not storage.stats_hidden);
	------------------------------------------------------------
  self.MovePanel = Turbine.UI.Control();
  self.MovePanel:SetParent(self);
  self.MovePanel:SetSize(2000,20);
  self.MovePanel:SetBackground("PvMP_Plus/Resources/dragbar.tga");

  self.MoveText = Turbine.UI.Label();
  self.MoveText:SetParent(self.MovePanel);
  self.MoveText:SetSize(width,12);
  self.MoveText:SetPosition(0,4);
  self.MoveText:SetFont(Turbine.UI.Lotro.Font.Verdana12);
  self.MoveText:SetText("PvMP+");
	self.MoveText:SetFontStyle(Turbine.UI.FontStyle.Outline);
  self.MoveText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.MoveText:SetMouseVisible(false);
	
	
	-- REPOSITIONING --
  -- shadow box
  self.shadowBox = Turbine.UI.Window();
  self.shadowBox:SetParent(self);
  self.shadowBox:SetPosition(0, 20);
	self.shadowBox:SetSize(width, height);
  self.shadowBox:SetMouseVisible(false);
  self.shadowBox:SetVisible(false);
	
  self.shadowBox.SizeChanged = function(sender, args)
      local width, height = sender:GetSize();
      self.shadowBox.topLeft:SetPosition(0, 0);
      self.shadowBox.top:SetPosition(10, 0);
      self.shadowBox.topRight:SetPosition(width - 10, 0);
      self.shadowBox.bottomLeft:SetPosition(0, height - 10);
      self.shadowBox.bottom:SetPosition(10, height - 10);
      self.shadowBox.bottomRight:SetPosition(width - 10, height - 10);
      self.shadowBox.left:SetPosition(0, 10);
      self.shadowBox.right:SetPosition(width - 10, 10);
        
      self.shadowBox.top:SetWidth(width - 20);
      self.shadowBox.bottom:SetWidth(width - 20);
      self.shadowBox.left:SetHeight(height - 20);
      self.shadowBox.right:SetHeight(height - 20);
  end
    
  -- top left corner
  self.shadowBox.topLeft = Turbine.UI.Control();
  self.shadowBox.topLeft:SetParent(self.shadowBox);
  self.shadowBox.topLeft:SetSize(10, 10);
  self.shadowBox.topLeft:SetMouseVisible(false);
  self.shadowBox.topLeft:SetBackground("PvMP_Plus/Resources/drag_topleft.tga");

  -- topRight
  self.shadowBox.topRight = Turbine.UI.Control();
  self.shadowBox.topRight:SetParent(self.shadowBox);
  self.shadowBox.topRight:SetSize(10, 10);
  self.shadowBox.topRight:SetMouseVisible(false);
  self.shadowBox.topRight:SetBackground("PvMP_Plus/Resources/drag_topright.tga");
    
  -- bottomLeft
  self.shadowBox.bottomLeft = Turbine.UI.Control();
  self.shadowBox.bottomLeft:SetParent(self.shadowBox);
  self.shadowBox.bottomLeft:SetSize(10, 10);
  self.shadowBox.bottomLeft:SetMouseVisible(false);
  self.shadowBox.bottomLeft:SetBackground("PvMP_Plus/Resources/drag_bottomleft.tga");

  -- bottomRight
  self.shadowBox.bottomRight = Turbine.UI.Control();
  self.shadowBox.bottomRight:SetParent(self.shadowBox);
  self.shadowBox.bottomRight:SetSize(10, 10);
  self.shadowBox.bottomRight:SetMouseVisible(false);
  self.shadowBox.bottomRight:SetBackground("PvMP_Plus/Resources/drag_bottomright.tga");

	-- top side
  self.shadowBox.top = Turbine.UI.Control();
  self.shadowBox.top:SetParent(self.shadowBox);
  self.shadowBox.top:SetSize(0, 10);
  self.shadowBox.top:SetMouseVisible(false);
  self.shadowBox.top:SetBackground("PvMP_Plus/Resources/drag_topmid.tga");

  -- left side
  self.shadowBox.left = Turbine.UI.Control();
  self.shadowBox.left:SetParent(self.shadowBox);
  self.shadowBox.left:SetSize(10, 0);
  self.shadowBox.left:SetMouseVisible(false);
  self.shadowBox.left:SetBackground("PvMP_Plus/Resources/drag_midleft.tga");

  -- right side
  self.shadowBox.right = Turbine.UI.Control();
  self.shadowBox.right:SetParent(self.shadowBox);
  self.shadowBox.right:SetSize(10, 0);
  self.shadowBox.right:SetMouseVisible(false);
  self.shadowBox.right:SetBackground("PvMP_Plus/Resources/drag_midright.tga");
    
  -- bottom side
  self.shadowBox.bottom = Turbine.UI.Control();
  self.shadowBox.bottom:SetParent(self.shadowBox);
  self.shadowBox.bottom:SetSize(0, 10);
  self.shadowBox.bottom:SetMouseVisible(false);
  self.shadowBox.bottom:SetBackground("PvMP_Plus/Resources/drag_bottommid.tga");
	
	self.shadowBox:SizeChanged();
	
  self.MovePanel:SetVisible(false);
  
  self.Moving = false;

  self.MovePanel.MouseDown = function(sender,args)
    self.MoveX = args.X;
    self.MoveY = args.Y;
    self.Moving = true;
    self.MovePanel:SetBackground("PvMP_Plus/Resources/dragbar_clicked.tga");
  end
    
  self.MovePanel.MouseUp = function(sender,args)
    self.Moving = false;
    self.MovePanel:SetBackground("PvMP_Plus/Resources/dragbar.tga");
  end
    
  self.MovePanel.MouseMove = function(sender,args)
    if self.Moving then
      local newLeft = self:GetLeft() - (self.MoveX - args.X);
      local newTop = self:GetTop() - (self.MoveY - args.Y);
      if newLeft < 0 then newLeft = 0 end;
      if newTop < 0 then newTop = 0 end;
      if newLeft > (Turbine.UI.Display.GetWidth() - self:GetWidth()) then
        newLeft = Turbine.UI.Display.GetWidth() - self:GetWidth() end;
      if newTop > (Turbine.UI.Display.GetHeight() - self:GetHeight()) then
        newTop = Turbine.UI.Display.GetHeight() - self:GetHeight() end;
			data.numbers.overview_x = newLeft;
			data.numbers.overview_y = newTop;
      self:UpdatePosition();
    end
  end

	self.MovePanel.MouseEnter = function(sender,args)
		self.shadowBox:SetVisible(true);
	end
		
	self.MovePanel.MouseLeave = function(sender,args)
		self.shadowBox:SetVisible(false);
	end
		
	self.label_points.MouseDown = function()
		storage.show_remaining_points = not storage.show_remaining_points;
		self:UpdateOverview();
	end
	
  self.KeyDown = function(sender,args) 
    if (args.Action == Turbine.UI.Lotro.Action.ToggleHUD) then
			self:SetVisible(not (self:IsVisible() or not overview_settings_panel.plusminus.visible)); -- toggle visibility of Overview-Window
			overview_settings_panel:SetVisible(not overview_settings_panel:IsVisible()); -- toggle visibility of Overview-Control
    elseif (args.Action == Turbine.UI.Lotro.Action.RepositionUI) then
      self.MovePanel:SetVisible(not self.MovePanel:IsVisible()); -- toggle visibility of MovePanel
    end
  end
	
end

function OverviewWindow:UpdateOverview(make_visible)

	if make_visible then
		self:SetVisible(not storage.minimized);
		overview_settings_panel:SetVisible(true);
		settings.reset_button:SetEnabled(true);
  end

	if self:GetWidth() < 600 then
		if storage.show_remaining_points then
			self.label_points:SetText(L.Overview_Remaining_Points_Short .. FormatPoints(GetRemainingPoints()));
		else
			self.label_points:SetText(L.Overview_Points_Short .. FormatPoints(data.numbers.points_total));
		end
		self.label_day:SetText(L.Overview_Day_Short .. FormatPoints(data.numbers.points_current_day));
		self.label_last_hour:SetText(L.Overview_Last_Hour_Short.. FormatPoints(GetPointsLastHour()));
		self.label_10min:SetText(L.Overview_Last_10min_Short .. FormatPoints(GetPointsLast10min()));
		self.label_last_fight:SetText(L.Overview_Last_Fight_Short .. FormatPoints(points_last_fight));
	else
		if storage.show_remaining_points then
			self.label_points:SetText(L.Overview_Remaining_Points .. FormatPoints(GetRemainingPoints()));
		else
			self.label_points:SetText(L.Overview_Points .. FormatPoints(data.numbers.points_total));
		end
		self.label_day:SetText(L.Overview_Day .. FormatPoints(data.numbers.points_current_day));
		self.label_last_hour:SetText(L.Overview_Last_Hour.. FormatPoints(GetPointsLastHour()));
		self.label_10min:SetText(L.Overview_Last_10min .. FormatPoints(GetPointsLast10min()));
		self.label_last_fight:SetText(L.Overview_Last_Fight .. FormatPoints(points_last_fight));
	end
	
	overview_settings_panel:UpdateChatData();
	
	for i=0, 14 do
		if (data.numbers.points_total >= Ranks[i] and data.numbers.points_total < Ranks[i+1]) then
			local rank_difference = Ranks[i+1] - Ranks[i];
			local points_since_rankup = data.numbers.points_total - Ranks[i];
			local percentage_done = points_since_rankup / rank_difference;
			self.pic_rank:SetBackground(Rank_Icons[i]);
			self.label_rank:SetText(L.Strings_Rank..i);
			self:UpdateProgressBar(percentage_done);
			return;
		end
	end
	self.pic_rank:SetBackground(Rank_Icons[15])
	self.label_rank:SetText(L.Strings_Rank.."15");
	self:UpdateProgressBar(1); -- Rank 15
end

function OverviewWindow:UpdateProgressBar(percentage_done)
	self.percentage:SetText(math.floor(percentage_done*10000)/100 .. "%");
	local filled_pixel = math.floor(self.bar_length * percentage_done);	
	self.filled_bar:SetWidth(filled_pixel);
end

function OverviewWindow:UpdatePosition()
	local old_width = self:GetWidth();
	local new_width = math.floor(minimal_width + (Turbine.UI.Display.GetWidth() - minimal_width) * data.numbers.overview_width_ratio);
	if new_width / 2 ~= math.floor((new_width + 1) / 2) then new_width = new_width + 1 end; -- true wenn new_width NICHT ohne rest durch 2 teilbar ist
	data.numbers.overview_x = data.numbers.overview_x - (new_width - old_width) / 2;
	if data.numbers.overview_x < 0 then data.numbers.overview_x = 0 end;
	if data.numbers.overview_x + new_width > Turbine.UI.Display.GetWidth() then data.numbers.overview_x = Turbine.UI.Display.GetWidth() - new_width end;
	self:SetWidth(new_width);
	self:SetPosition(data.numbers.overview_x,data.numbers.overview_y);
	self:UpdateBarLength();
  self.separator:SetWidth(self:GetWidth());
	self.label_commendations:SetPosition(self:GetWidth()-self.label_commendations:GetWidth(),48);
	self.pic_commendations:SetPosition(self:GetWidth()-27-16,18);
  self.label_points:SetSize(self:GetWidth() - 108,20); -- label direkt zwischen rank- und commendations-label
  self.label_day:SetSize(self:GetWidth()/4,20);
  self.label_last_hour:SetSize(self:GetWidth()/4,20);
	self.label_last_hour:SetPosition(self:GetWidth()/4,70);
  self.label_10min:SetSize(self:GetWidth()/4,20);
	self.label_10min:SetPosition(2 * self:GetWidth()/4,70);
  self.label_last_fight:SetSize(self:GetWidth()/4,20);
	self.label_last_fight:SetPosition(3 * self:GetWidth()/4,70);
	self.shadowBox:SetWidth(self:GetWidth());
  self.MoveText:SetWidth(self:GetWidth());
	overview_settings_panel:SetPosition(self:GetLeft() + self:GetWidth() - overview_settings_panel:GetWidth(), self:GetTop());	
end

function OverviewWindow:UpdateBarLength()
	self.bar_start = 50;
	self.bar_end = self:GetWidth() - self.bar_start;
	self.bar_length = self.bar_end - self.bar_start;
	self.empty_bar:SetWidth(self.bar_length);
	self.middle:SetWidth(self.bar_length-6);
	self.right_end:SetPosition(self.bar_end-3,25);
	self.percentage:SetWidth(self:GetWidth());
	self:UpdateOverview();
end

function OverviewWindow:ToggleStatsVisibility()
	storage.stats_hidden = self.separator:IsVisible();
	self:SetStatsVisibility(not storage.stats_hidden);	
end
		
function OverviewWindow:SetStatsVisibility(flag)
	self.separator:SetVisible(flag);
	self.label_day:SetVisible(flag);
	self.label_last_hour:SetVisible(flag);
	self.label_10min:SetVisible(flag);
	self.label_last_fight:SetVisible(flag);
end