Settings = class(Turbine.UI.Window);
 
function Settings:Constructor()

	local width = 200;
  local height = 230;
  local x = Turbine.UI.Display:GetWidth()/2 - width/2;
  local y = Turbine.UI.Display:GetHeight()/2 - height/2;

  Turbine.UI.Lotro.Window.Constructor(self);
  
  self:SetSize(width,height);
  self:SetPosition(x,y);
	self:SetZOrder(1);
  self:SetText("PvMP+");
	------------------------------------------------------------
	self.update_button = Turbine.UI.Lotro.Button();
	self.update_button:SetText(L.Options_Update);
	self.update_button:SetSize(width - 40,30);
	self.update_button:SetPosition(width/2 - self.update_button:GetWidth()/2,50);
	self.update_button:SetParent(self);

	self.reset_button = Turbine.UI.Lotro.Button();
	self.reset_button:SetText(L.Options_Reset);
	self.reset_button:SetSize(width - 40,30);
	self.reset_button:SetPosition(width/2 - self.reset_button:GetWidth()/2,80);
	self.reset_button:SetParent(self);
	self.reset_button:SetEnabled(false);
	
	self.show_stats_checkbox = Turbine.UI.Lotro.CheckBox();
	self.show_stats_checkbox:SetParent(self);
	self.show_stats_checkbox:SetText("");
	self.show_stats_checkbox:SetPosition(width/2 - self.reset_button:GetWidth()/2 + 1,94);
	self.show_stats_checkbox:SetChecked(not storage.stats_hidden);
	
	self.show_stats_label = Turbine.UI.Label();
	self.show_stats_label:SetText(L.Options_Show_Stats);
	self.show_stats_label:SetSize(width,30);
	self.show_stats_label:SetPosition(width/2 - self.reset_button:GetWidth()/2 + 23,104);
	self.show_stats_label:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.show_stats_label:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.show_stats_label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.show_stats_label:SetParent(self);

	self.slider_label = Turbine.UI.Label();
	self.slider_label:SetText(L.Options_Window_Size);
	self.slider_label:SetParent(self);
	self.slider_label:SetSize(width,30);
	self.slider_label:SetPosition(width/2 - self.slider_label:GetWidth()/2 + 23,130);
	self.slider_label:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.slider_label:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.slider_label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	
	self.slider_bar = Turbine.UI.Label();
	self.slider_bar:SetParent(self);
	self.slider_bar:SetSize(width - 40,15);
	self.slider_bar:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
	self.slider_bar:SetBackground("PvMP_Plus/Resources/slider_bar.tga");
	self.slider_bar:SetPosition(20,157);

	self.slider = Turbine.UI.Control();
	self.slider:SetParent(self);
	self.slider:SetSize(16,16);
	self.slider:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
	self.slider:SetBackground(0x41007e0c);
	self.slider:SetPosition(20 + data.numbers.overview_width_ratio * (self.slider_bar:GetWidth() - 20),157);


	self.slider.MouseDown = function(sender,args)
    self.MoveX = args.X;
    self.MoveY = args.Y;
    self.sliding = true;
  end
    
  self.slider.MouseUp = function(sender,args)
    self.sliding = false;
  end
    
  self.slider.MouseMove = function(sender,args)
    if self.sliding then
      local newLeft = self.slider:GetLeft() - (self.MoveX - args.X);
      if newLeft < 20 then newLeft = 20 end;
      if newLeft > 164 then newLeft = 164 end;
			self.slider:SetPosition(newLeft, self.slider:GetTop());
			data.numbers.overview_width_ratio = (newLeft - 20) / (self.slider_bar:GetWidth() - self.slider:GetWidth());

      overviewWindow:UpdatePosition();
    end
  end
	
	
	self.ok_button = Turbine.UI.Lotro.Button();
	self.ok_button:SetText("OK");
	self.ok_button:SetPosition(width/2 - self.ok_button:GetWidth()/2,185);
	self.ok_button:SetParent(self);
	
	
	self.show_stats_checkbox.CheckedChanged = function()
		overviewWindow:ToggleStatsVisibility();
	end
	
	self.update_button.Click = function()
		initWindow:Open();
	end

	self.reset_button.Click = function()
		data.numbers.overview_y = 0;
		data.numbers.overview_width_ratio = 0.3;
		data.numbers.overview_x = Turbine.UI.Display.GetWidth()/2 - overviewWindow:GetWidth()/2;
		self.slider:SetPosition(20 + data.numbers.overview_width_ratio * (self.slider_bar:GetWidth() - 20),157);
		overview_settings_panel.plusminus:SetBackground("PvMP_Plus/Resources/minus.tga");
		storage.show_remaining_points = false;
		overviewWindow:SetVisible(true);
		self.show_stats_checkbox:SetChecked(true);
		overviewWindow:UpdatePosition();
	end
	
	self.ok_button.Click = function()
		self:SetVisible(false);
	end
	
end

function Settings:Open()
	self:SetVisible(true);
end